var main_tizen = {
}
var player = null;
var transfer = false;
var manager = false;
var timerService = null;

var service_timer = false;

$(document).ready(function(){
	tizen.tvinputdevice.registerKey('0');
	tizen.tvinputdevice.registerKey('1');
	tizen.tvinputdevice.registerKey('2');
	document.addEventListener('keydown', self.onKeyDown, false);
	try{
		if(!player){
			player = new PlayerController();
			$(player).on("PlayerDataLoaded",onPlayerDataLoaded);
			player.init();
		}
	}catch(e){
		$("#starter").html("System in recovery mode.");
		try{
			if(!transfer){
					transfer = new TransferService();
					transfer.setTimeCallback = player.setUseServerTime;
					transfer.init(player.version,player.platform);
			}
			transfer.activateLogger(player.debug);
			transfer.update(player.timestamp);
		}catch(e){
			console.log("Unable to start transfer");
		}
		try{
			schedule = player.config.getScheduleConfig();
		}catch(e){
			console.log("No Schedule !");
		}
		try{
			if(!manager){
					manager = new ManagerService();
					manager.init();
					try{
						transfer.onUpdatedManagerInterval = function(interval){
							console.log("Checking ManagerService Interval");
							manager.checkInterval(interval);
						};
					}catch(e){
						console.log("Could not check interval for management");
					}
			}
			manager.activateLogger(player.debug);
			manager.update(schedule);
		}catch(e){
			console.log("Unable to start manager");
		}
	}
});


function onPlayerDataLoaded(){
	$("#starter").hide();
	try{
		if(!transfer){
				transfer = new TransferService();
				transfer.setTimeCallback = player.setUseServerTime;
				transfer.init(player.version,player.platform);
		}
		transfer.activateLogger(player.debug);
		transfer.update(player.timestamp);
	}catch(e){
		console.log("Unable to start transfer");
	}
	try{
		schedule = player.config.getScheduleConfig();
	}catch(e){
		console.log("No Schedule !");
	}
	try{
		if(!manager){
				manager = new ManagerService();
				manager.init();
				try{
					transfer.onUpdatedManagerInterval = function(interval){
						console.log("Checking ManagerService Interval");
						manager.checkInterval(interval);
					};
				}catch(e){
					console.log("Could not check interval for management");
				}
		}
		manager.activateLogger(player.debug);
		manager.update(schedule);
	}catch(e){
		console.log("Unable to start manager");
	}
	setTimeout(function(){
		if(!timerService){
			timerService = new TimerService();
		}
		timerService.checkTimers(schedule);
	}, 15000);
	setTimeout(function(){transfer.OS.insertTimersOrReboot(player.config.getForceReboot24h());}, 30000);
	if(!service_timer){
			service_timer = setInterval(service,10000);
	}
}

function service(){
	if(player){
		player.service();
		try{
			if(transfer){
					transfer.updateInfo(player.name,player.getInfo());
			}
		}catch(e){
			console.log("Unable to update player info for transfer");
		}
	}
}

this.onKeyDown = function (event) {
	"use strict";
	var keyCode = event.keyCode;

	switch (keyCode) {
			case 37:
					player.playlist.jump(-1);
					break;
			case 39:
					player.playlist.jump();
					break;
			case 49:
					player.toggleCoreSetupWindow();
					break;
			case 50:
          player.toggleProxySetupWindow();
          break;
	    case 48:    // MediaPause
	    	player.debug = !player.debug;
				try{
					player.setLogger($("#playerLog"));
					player.activateLogger(player.debug);
				}catch(e){
					console.log("Error on player toggle debug");
				}
				try{
					transfer.setLogger($("#transferLog"));
					transfer.activateLogger(player.debug);
					manager.setLogger($("#transferLog"));
				}catch(e){
					console.log("Error on transfer toggle debug");
				}
			break;
		default:
			player.log(keyCode);
		break;
	}
};
