function ManagerService(){
    if(arguments.callee._singletonInstance){
        return arguments.callee._singletonInstance;
    }
    arguments.callee._singletonInstance = this;

    var self = this; self.name = "ManagerService"; // MANDATORY

    this.interval = 23000;
    this.timer = 0;
    this.last_tunnel_params = "";
    this.schedule = false;
    this.timeUpgrade = (new Date()).getTime();

    this.init = function(platform){
        self.setPlatform(platform);
        if(!self.timer){
            self.management();
        }
    };

    this.update = function(schedule){
        if(typeof(schedule) !== "undefined"){
            self.schedule = null;
            self.schedule = schedule;
        }
    };

    this.management = function(){
        clearTimeout(self.timer);
           self.timer = setTimeout(self.management, self.intervalManagement);
        self.internet_connected = self.OS.internetConnected();
        if(self.internet_connected){
            self.log("# Management beat ... for : "+self.core_id);
            if(self.core_id != "0"){
              self.api_connector.get(self.api_url,self.api_ver,"player/management/plv_id",self.core_id,self.managementResponse);
            }else{
              if(typeof(self.OS.SocketConnector) === "undefined"){
                self.setPlatform();
                self.OS.init(self.init_failover);
              }
            }
            //self.OS.get_tunnels_params();
        }else{
            self.log("# Management beat ... no internet");
            self.notifyError(self.ERROR['MANAGER_SERVICE']+2,self.name+": Function management() : internet connection LOST ! ");
        }
        self.checkConfigSchedule();
    };

    this.init_failover = function(){
        self.OS.enableRemoteControl();
        self.OS.readFile(self.ROUTES['CORE'].path,function(data){
          if(data !==  ""){
              self.setAPIroutes(data);
              self.ROUTES['CORE'].exists = true;
          }
        });
    };

    this.remoteResponse = function(response,status,params){
        if(status == "success"){
            self.log("Management Tunnels Response : "+response);
            if(response == " "){response = "";}
            if(self.last_tunnel_params != response){
                self.last_tunnel_params = response;
                if(self.last_tunnel_params  == ""){
                    self.last_tunnel_params = response;
                    self.OS.disableRemoteControl(self.platform);
                    self.log("Management Tunnels Response : "+response);
                }else{
                    self.last_tunnel_params = response;
                    self.OS.enableRemoteControl(self.platform,self.last_tunnel_params);
                }
            }
        }
    };

    this.managementResponse = function(response,status,params){
        if(status == "success"){
            var action = "0";
            if(parseInt(self.core_id) > 0){
                var parser=new DOMParser();
                var xmlDoc=parser.parseFromString(response,"text/xml");
                action = ""+xmlDoc.getElementsByTagName("action")[0].childNodes[0].nodeValue;
                self.log("Management Action : "+action);
                switch (action){
                    case "1":
                        /// REBOOT
                        self.notifyError(self.ERROR['MANAGER_SERVICE']+1,self.name+": Reboot required from server.");
                        self.OS.rebootSystem(self.platform);
                    break;
                    case "2":
                        //apagar
                    break;
                    case "3":
                        if(!self.OS.systemIsUpdating){
                            /// SOFTWARE UPGRADE
                            var upgrade_url = self.api_connector.buildUrl(self.api_url,self.api_ver,"player/upgrade/id/"+self.core_id);
                            self.log("Software upgrade needed ... trying to download from : "+upgrade_url);
                            var options = {'filename':'upgrade.zip'};

                            self.OS.deleteFile('upgrade.zip', function(){
                                self.OS.downloadFile(upgrade_url,"",self.onUpgradeDownloadComplete,options);
                                self.notifyError(self.ERROR['MANAGER_SERVICE']+1,self.name+": Software Upgrade required from server.");
                            })
                        }
                    break;
                    case "4":
                      if(!self.OS.systemIsUpdating){
                        var upgrade_firmware_url = self.api_connector.buildUrl(self.api_url,self.api_ver,"player/upgrade_firmware/id/"+self.core_id);
                        self.api_connector.get(self.api_url,self.api_ver,"player/upgrade_firmware/id/",self.core_id,function(response,status){
                            if(status == "success"){
                              try{
                                var upgrade_data = JSON.parse(response);
                                self.OS.updateFirmware(upgrade_data, function(ok){
                                    self.notifyError(self.ERROR['MANAGER_SERVICE']+1,self.name+": Software Firmware Upgrade required from server : "+ok);
                                },self.platform);
                              }catch(e){
                                self.log("Unable to get Data for Firmware upgrade ... ");
                              }
                            }
                        });

                      }
                    break;
                    case "5":
                        //controllook for Remote Tunnel Control
                        self.api_connector.get(self.api_url,self.api_ver,"player/get_tunnels_params/id",self.core_id,self.remoteResponse);
                    break;
                    case "6":
                        self.OS.takeScreenshot(function(base64Image){});
                    break;
                    case "7":
                        //borrar memoria
                        self.OS.deleteAll(function(result){})
                    break;
                    case "8":
                      if(!self.OS.systemIsUpdating){
                        self.OS.reload(self.platform);
                      }
                    break;
                    case "9":
                      self.OS.activateSocketBasic();
                    break;
                }
                parser = null;
                xmlDoc = null;
            }
            action = null;
        }
    };

    this.onUpgradeDownloadComplete = function(ok,url,params){
        if(ok){
            self.log("Upgrade downloaded.");
            self.OS.unzipFile("upgrade.zip",self.ROUTES['TMP'].path+"upgrade/"+self.timeUpgrade+"/", function(ok,file_ref,params){
                self.OS.deleteFile("upgrade.zip");
                if(ok){
                    self.log("Upgrade unzipped in : "+self.OS.rootDir+self.ROUTES['TMP'].path+"upgrade/"+self.timeUpgrade+"/");
                    self.OS.systemUpdate(self.ROUTES['TMP'].path+"upgrade/"+self.timeUpgrade+"/",self.platform);
                }else{
                     self.notifyError(self.ERROR['MANAGER_SERVICE']+3,self.name+": Function onUpgradeDownloadComplete() failed : could not unzip Upgrade package ");
            self.log("Error downloading upgrade version.");
                    self.log("Upgrade NOT unzipped !");
                }
            });
        }else{
            self.notifyError(self.ERROR['MANAGER_SERVICE']+3,self.name+": Function onUpgradeDownloadComplete() failed : could not Download Upgrade package. Try to set Unsecure Connection for download");
            self.log("Error downloading upgrade version. Try to set Unsecure Connection for download");
            self.api_connector.setSecureConnection(false);
        }
    };

    this.checkConfigSchedule = function(){
        if(self.schedule){
            self.log("self.schedule:"+self.schedule);
            if(self.schedule.timetable != false){
                var dow = self.getDayOfWeek();
                var date = null;
                var check =((dow-1)*24);
                if(self.platform == "SOC"){
                    date = self.getDate(true);
                    check += date.getHours();
                    self.log("Checking for day of week : "+dow+" on hour : "+date.getHours()+" Check hour of the week : "+check+" -> is ON Air ? "+Boolean(self.schedule.timetable[check]));
                }else{
                    if(self.platform == "TIZEN"){
                        date = self.getDate(self.server_time_activated);
                        check +=  date.getUTCHours();
                        self.log("Checking for day of week : "+dow+" on hour : "+date.getUTCHours()+" Check hour of the week : "+check+" -> is ON Air ? "+Boolean(self.schedule.timetable[check]));
                    }else{
                        date = self.getDate();
                        check += date.getHours();
                        self.log("Checking for day of week : "+dow+" on hour : "+date.getHours()+" Check hour of the week : "+check+" -> is ON Air ? "+Boolean(self.schedule.timetable[check]));
                    }
                }
                if(!Boolean(self.schedule.timetable[check])){
                  if(Boolean(self.schedule.halt)){
                    self.log("Halt System !!!");
                    self.OS.haltSystem(self.platform);
                  }else{
                    self.log("Screen Off !!!");
                    self.OS.setPanelOff();
                  }
                }else{
                  if(!Boolean(self.schedule.halt)){
                    self.log("Screen On !!!");
                    self.OS.setPanelOn();
                  }
                }
                dow = null;
                date = null;
                check = null;
            }
        /*
        }else{
          if(!Boolean(self.schedule.halt)){
            self.log("Screen On !!!");
            self.OS.setPanelOn();
          }
        */
        }
    };
    
    this.checkInterval = function(new_interval){
      if(new_interval != self.intervalManagement){
        self.intervalManagement = new_interval
      }
      clearTimeout(self.timer);
      self.timer = setTimeout(self.management, self.intervalManagement);       
    };
}
ManagerService.prototype = new BasicService();
